package com.rhiannonweb.android.migrainetracker;

import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import com.rhiannonweb.android.migrainetracker.data.Headache;
import com.rhiannonweb.android.migrainetracker.ui.DetailsDialog;

public class MigraineTracker extends Activity {
	Button dp;
	boolean isMigraine = false;
	Headache owie;
	
	private static final String MIGRAINE_STATE = "CURRENT_STATE";
	private static final String MIGRAINE_START = "START_DATE";
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        dp = new Button(this);
        if (savedInstanceState != null && savedInstanceState.containsKey(MIGRAINE_STATE)) {
        	onRestoreInstanceState(savedInstanceState);
        }
        
        dp.setText(isMigraine ? R.string.stop_migraine : R.string.start_migraine);
        dp.setTextSize(dp.getTextSize() * 2);
        dp.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				toggleMigraine();
		        dp.setText(isMigraine ? R.string.stop_migraine : R.string.start_migraine);
			}
        	
        });
        setContentView(dp);
    }
    
    protected void toggleMigraine() {
    	if (isMigraine) {
    		stopMigraine();
    	} else {
    		startMigraine();
    	}
		isMigraine = !isMigraine;
	}

	protected void startMigraine() {
		owie = new Headache();
		// TODO: Write to DB
	}

	protected void stopMigraine() {
		owie.end();
		Dialog info = new DetailsDialog(this, false, null, owie);
		info.show();
		
		// Allow GC to carry away our pain
		owie = null;
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inf = getMenuInflater();
		inf.inflate(R.menu.main_menu, menu);
		return super.onCreateOptionsMenu(menu);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.history:
			Intent i = new Intent(this, HeadacheListActivity.class);
			startActivity(i);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
    
    @Override
    public void onSaveInstanceState(Bundle savedInstanceState) {
    	super.onSaveInstanceState(savedInstanceState);
    	
    	savedInstanceState.putBoolean(MIGRAINE_STATE, isMigraine);
    	if (isMigraine && owie != null) {
    		savedInstanceState.putLong(MIGRAINE_START, owie.getBeginDate().getTime());
    	}
    }
    
    @Override
    public void onRestoreInstanceState(Bundle savedInstanceState) {
    	super.onRestoreInstanceState(savedInstanceState);
    	
    	isMigraine = savedInstanceState.getBoolean(MIGRAINE_STATE, false);
    	if (isMigraine) {
    		owie = new Headache(savedInstanceState.getLong(MIGRAINE_START));
    	}
    }
}